// use alchemist's workbench. make transformation if 2 valid objects found and if party's skill ok

const string EMPTY_BOTTLE =  "NW_IT_THNMISC001";
const string HEAL_POTION = "nw_it_mpotion020";
const string HEAL_POTION_TAG = "NW_IT_MPOTION020";
const string HEAL_IMPORTANT = "nw_it_mpotion002";
const string HEAL_IMPORTANT_TAG = "NW_IT_MPOTION002";
const string HEAL_INTENSIVE = "nw_it_mpotion003";
const string ANTIDOTE_POTION = "nw_it_mpotion006";
const string RECOVERY_POTION = "n2_it_mpotion001";
const string SPLENDOUR_POTION ="nw_it_mpotion010";
const string RESTORATION_POTION ="nw_it_mpotion011";
const string SUPREME_POTION = "nw_it_mpotion012";
const string FORCE_POTION = "NW_IT_MPOTION015"; 
const string ARROWS = "NW_WAMAR001";
const string POISONED_ARROWS = "nw_wammar007";
const string BOLTS = "NW_WAMBO001";
const string POISONED_BOLTS = "nw_wammbo006";

int GetPartySkill(int nTestedSkill)
{
	object oNPC;
	int n = GetSkillRank(nTestedSkill, GetFirstPC());	
	string sRoster = GetFirstRosterMember();
	int p;
	while (sRoster != "")
	{
		p = 0;
		oNPC = GetObjectByTag(sRoster);
		if (GetFactionEqual(oNPC, GetFirstPC())) p = GetSkillRank(nTestedSkill, oNPC);	// if in party
		if (p > n) n = p;
		sRoster = GetNextRosterMember();
	}
	return (n);
}

string Try(object oB1, object oB2, string s1, string s2, string sResult, int nSkill)
{
	string sC ="";
	if ((!GetIdentified(oB1))||(!GetIdentified(oB2))) return (sC);
	if ((GetTag(oB1)==s1)&&(GetTag(oB2)==s2)) sC = sResult;
	if ((GetTag(oB1)==s2)&&(GetTag(oB2)==s1)) sC = sResult;
	
	if (sC != "")
		if (GetPartySkill(SKILL_CRAFT_ALCHEMY) < nSkill)		// not enough skill
		{
			SendMessageToPC(GetFirstPC(), "Compétence insuffisante / Not enough skill.");
			sC = "";
		}
	return (sC);	
}

int Max(int n, int p)
{
	if ( p > n) return (p); else return (n);
}

void main()
{
	object oWB = OBJECT_SELF;
	object oB1 = GetFirstItemInInventory(oWB);
	object oB2 = GetNextItemInInventory(oWB);
	object oPC = GetFirstPC();
	string sOB = "";
	int nStack = 1;
	
	sOB = Try(oB1, oB2, EMPTY_BOTTLE, "anthemis", HEAL_POTION, 3);					// potions and powder
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "filipendula", RECOVERY_POTION, 3);
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "melissa", ANTIDOTE_POTION, 3);
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "aloes", RESTORATION_POTION, 6);
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "rose", SPLENDOUR_POTION, 6);
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "allium", FORCE_POTION, 6);
	if (sOB=="") sOB = Try(oB1, oB2, EMPTY_BOTTLE, "mandrake", SUPREME_POTION, 9);
	if (sOB=="") sOB = Try(oB1, oB2, "saltpeter", "charcoal", "powder", 9);
	if (sOB=="") sOB = Try(oB1,oB2, HEAL_POTION_TAG, "filipendula", HEAL_IMPORTANT, 9);
	if (sOB=="") sOB = Try(oB1,oB2, HEAL_POTION_TAG, "allium", HEAL_IMPORTANT, 9);
	if (sOB=="") sOB = Try(oB1,oB2, HEAL_IMPORTANT_TAG, "filipendula", HEAL_INTENSIVE, 12);
	if (sOB=="") sOB = Try(oB1,oB2, HEAL_IMPORTANT_TAG, "allium", HEAL_INTENSIVE, 12);	

	if (sOB=="")																	// ammunitions
	{
		nStack = Max(GetItemStackSize(oB1), GetItemStackSize(oB2));
		sOB = Try(oB1, oB2, ARROWS, "aconit", POISONED_ARROWS, 4);
		if (sOB=="") sOB = Try(oB1, oB2, BOLTS, "aconit", POISONED_BOLTS, 4);
	}
	
	if (sOB=="") return;

	DestroyObject(oB1);
	DestroyObject(oB2);
	oB1 = CreateItemOnObject(sOB, oWB);
	SetItemStackSize(oB1, nStack, FALSE);
	
	SendMessageToPC(oPC, "Objet créé / Object created.");	 
}