// use blacksmith's workbench. make transformation if 2 valid objects found and if party's skill ok

const string IRON_LINGOT = "n2_crft_ingiron";
const string LEATHER = "n2_crft_hideleather";
const string ALCOHOL = "NW_IT_MPOTION022";
const string SCOPED = "Scoped ";
const string LASER =  "Laser- ";

#include "x2_inc_itemprop"

int GetPartySkill(int nTestedSkill)
{
	object oNPC;
	int n = GetSkillRank(nTestedSkill, GetFirstPC());	
	string sRoster = GetFirstRosterMember();
	int p;
	while (sRoster != "")
	{
		p = 0;
		oNPC = GetObjectByTag(sRoster);
		if (GetFactionEqual(oNPC, GetFirstPC())) p = GetSkillRank(nTestedSkill, oNPC);	// if in party
		if (p > n) n = p;
		sRoster = GetNextRosterMember();
	}
	return (n);
}

string Try(object oB1, object oB2, string s1, string s2, string sResult, int nSkill, int nSkillType)
{
	string sC ="";
	if ((!GetIdentified(oB1))||(!GetIdentified(oB2))) return (sC);
	if ((GetTag(oB1)==s1)&&(GetTag(oB2)==s2)) sC = sResult;
	if ((GetTag(oB1)==s2)&&(GetTag(oB2)==s1)) sC = sResult;
	
	if (sC != "")
		if (GetPartySkill(nSkillType) < nSkill)		// not enough skill
		{
			SendMessageToPC(GetFirstPC(), "Compétence insuffisante / Not enough skill.");
			sC = "";
		}
	return (sC);	
}

int TryImproving(object oB1, object oB2, string s1, int nSkill, int nSkillType, int MaxBonus, string sScope)
{
	int ok = FALSE;
	object oB = oB2;
	if ((!GetIdentified(oB1))||(!GetIdentified(oB2))) return (ok);
	if ((GetTag(oB1)==s1)&&(GetWeaponRanged(oB2))) ok = TRUE;
	if ((GetTag(oB2)==s1)&&(GetWeaponRanged(oB1))) {ok = TRUE; oB = oB1; oB1 = oB2;} 
	
	if (ok)
		if (GetPartySkill(nSkillType) < nSkill)		// not enough skill
		{
			SendMessageToPC(GetFirstPC(), "Compétence insuffisante / Not enough skill.");
			ok = FALSE;
		}
		else										// modify object
		{
			DestroyObject(oB1);
			IPSafeAddItemProperty(oB, ItemPropertyAttackBonus(MaxBonus), 0.0f, X2_IP_ADDPROP_POLICY_REPLACE_EXISTING);
			if (GetStringLeft(GetFirstName(oB), 7)!=sScope) SetFirstName(oB, sScope+GetFirstName(oB));  
			SendMessageToPC(GetFirstPC(), "Objet modifié / Object modified."); 
		}		
	return (ok);	
}

void main()
{
	object oWB = OBJECT_SELF;
	object oB1 = GetFirstItemInInventory(oWB);
	object oB2 = GetNextItemInInventory(oWB);
	object oPC = GetFirstPC();
	string sOB = "";
	
	sOB = Try(oB1, oB2, LEATHER, IRON_LINGOT, "protection_gauntlet", 3, SKILL_CRAFT_ARMOR);
	if (sOB=="") sOB = Try(oB1, oB2, "material", ALCOHOL, "molotov_cocktail", 4, SKILL_CRAFT_WEAPON);
	if (sOB=="") sOB = Try(oB1, oB2, "tube", "cannon_ball", "hand_cannon", 9, SKILL_CRAFT_WEAPON);
	if (sOB=="") sOB = Try(oB1, oB2, "hand_cannon", "powder", "cannon", 9, SKILL_CRAFT_WEAPON);
	 	
	if (sOB!="")
	{
		DestroyObject(oB1);
		DestroyObject(oB2);
		oB1 = CreateItemOnObject(sOB, oWB);
	 	SendMessageToPC(oPC, "Objet créé / Object created.");
		return;
	}
	int ok = TryImproving(oB1, oB2, "iron_piece", 6, SKILL_CRAFT_WEAPON, 2, SCOPED);
	if (!ok) TryImproving(oB1, oB2, "laser_sight", 12, SKILL_CRAFT_WEAPON, 4, LASER);  
}